﻿Imports MySql.Data.MySqlClient

Public Class Connection

    '
    'Privát adattagok a mysql kapcsolathoz, parancs futtatásához, eredmény olvasásához
    '
    Dim comm As New MySqlCommand
    Dim conn As New MySqlConnection
    Dim reader As MySqlDataReader
    Dim sql As String

    '
    'Beállítjuk a MySql kapcsolat kapcsolódási stringjét
    '
    Public Sub SetConnectionString(ByVal srv As String, ByVal name As String, ByVal pwd As String, ByVal db As String)
        conn.ConnectionString = "server=" & srv & "; " _
                     & "user id=" & name & "; password=" & pwd _
                     & "; database=" & db
    End Sub

    '
    'A beszur fv paraméterként egy sql utasítást kap, és azt végrehajtja.
    'True -val tér vissza, ha sikerült, egyébként False -al
    '
    Public Function beszur(ByVal mit As String) As Boolean
        If (mit <> "") Then
            Try
                conn.Open()
                comm.Connection = conn
                comm.CommandText = mit
                comm.ExecuteReader()
                conn.Close()
            Catch myerror As MySqlException
                MessageBox.Show("Hiba " & myerror.Message & ": " & comm.CommandText)
                Return False
            Finally
                conn.Dispose()
            End Try
            Return True
        End If
        Return False
    End Function

    '
    'A feltolt eljárás kap egy comboBox -ot paraméterként referencia szerint,
    'ezt tölti fel a megfelelő értékkel, jelen esetben a kérdéskörökkel
    '
    Public Sub feltolt(ByRef mit As System.Windows.Forms.ComboBox)
        Try
            conn.Open()
            comm.Connection = conn
            comm.CommandText = "SELECT nev FROM kerdeskor;"
            reader = comm.ExecuteReader()
            While reader.Read()
                mit.Items.Add(reader(0))
            End While
            conn.Close()
        Catch myerror As MySqlException
            MessageBox.Show("Hiba " & myerror.Message)
        Finally
            conn.Dispose()
        End Try
    End Sub

    '
    'A feltoltPont eljárás kap egy comboBox -ot paraméterként referencia szerint,
    'ezt tölti fel a megfelelő értékkel, jelen esetben a pontszámokkal
    '
    Public Sub feltoltPont(ByRef mit As System.Windows.Forms.ComboBox, ByVal id As Integer)
        Dim max As Integer = 100
        conn.Open()
        comm.Connection = conn
        comm.CommandText = "SELECT MAX(pont) AS max FROM kerdesek WHERE kor_id =" & id & ";"
        reader = comm.ExecuteReader()
        If reader.Read() Then
            If reader.IsDBNull(0) Then
                max = 100
            Else
                max = reader("max") + 100
            End If
        End If
        conn.Close()

        For i As Integer = 100 To max Step 100
            mit.Items.Add(i)
        Next i
    End Sub

    '
    'Paraméterként kapott nev alapján ez a fv visszaadja a megfelelő
    'kérdéskör id -jét
    '
    Public Function getCsopId(ByVal nev As String) As Integer
        Dim vissza As Integer = -1
        sql = "SELECT id FROM kerdeskor WHERE nev ='" & nev & "';"
        Try
            conn.Open()
            comm.Connection = conn
            comm.CommandText = sql
            reader = comm.ExecuteReader()
            If reader.Read() Then
                vissza = reader("id")
            End If
            conn.Close()
        Catch myerror As MySqlException
            MessageBox.Show("Hiba " & myerror.Message & ": " & comm.CommandText)
            Return vissza
        Finally
            conn.Dispose()
        End Try
        Return vissza
    End Function

    Public Function getCsopNev(ByVal id As Integer) As String
        Dim vissza As String = ""
        sql = "SELECT nev FROM kerdeskor WHERE id =" & id & ";"
        Try
            conn.Open()
            comm.Connection = conn
            comm.CommandText = sql
            reader = comm.ExecuteReader()
            If reader.Read() Then
                vissza = reader("nev")
            End If
            conn.Close()
            Return vissza
        Catch myerror As MySqlException
            MessageBox.Show("Hiba " & myerror.Message & ": " & comm.CommandText)
        Finally
            conn.Dispose()
        End Try
        Return vissza
    End Function


    Public Function getKerdeskorCount() As Integer
        Dim vissza As Integer = 0
        sql = "SELECT COUNT(id) AS id FROM kerdeskor;"
        Try
            conn.Open()
            comm.Connection = conn
            comm.CommandText = sql
            reader = comm.ExecuteReader()
            If reader.Read Then
                vissza = reader("id")
            End If
            conn.Close()
            Return vissza
        Catch myerror As MySqlException
            MessageBox.Show("Hiba " & myerror.Message & ": " & comm.CommandText)
        Finally
            conn.Dispose()
        End Try
        Return vissza
    End Function

    Public Function getKerdesekCount(ByVal id As Integer) As Integer
        Dim vissza As Integer = 0
        sql = "SELECT COUNT(id) AS id FROM kerdesek WHERE kor_id = " & id & " GROUP BY pont;"
        Try
            conn.Open()
            comm.Connection = conn
            comm.CommandText = sql
            reader = comm.ExecuteReader()
            While reader.Read()
                vissza += 1
            End While
            conn.Close()
            Return vissza
        Catch myerror As MySqlException
            MessageBox.Show("Hiba " & myerror.Message & ": " & comm.CommandText)
        Finally
            conn.Dispose()
        End Try
        Return vissza
    End Function

    Public Sub getKerdes(ByRef ar As Array, ByVal kor_id As Integer, ByVal pont As Integer)
        sql = "SELECT kerdes, jovalasz, rosszvalasz1, rosszvalasz2, rosszvalasz3 FROM kerdesek WHERE"
        sql &= " kor_id = " & kor_id & " AND pont = " & pont & " ORDER BY RAND() LIMIT 0,1;"
        Try
            conn.Open()
            comm.Connection = conn
            comm.CommandText = sql
            reader = comm.ExecuteReader()
            If reader.Read() Then
                ar(0) = reader(0)
                ar(1) = reader(1)
                ar(2) = reader(2)
                ar(3) = reader(3)
                ar(4) = reader(4)
            End If
            conn.Close()
        Catch myerror As MySqlException
            MessageBox.Show("Hiba " & myerror.Message & ": " & comm.CommandText)
        Finally
            conn.Dispose()
        End Try
    End Sub

    '
    'Visszaadja a kapcsolat connection stringjét
    '
    Public Function getConnString() As String
        Return conn.ConnectionString
    End Function

    '
    'Kipróbáljuk a kapcsolatot, hogy működik-e, ha nem False értékkel tér vissza,
    'ha igen, akkor True -val
    '
    Public Function tryConnection() As Boolean
        Try
            conn.Open()
            conn.Close()
        Catch myerror As MySqlException
            Return False
        Finally
            conn.Dispose()
        End Try
        Return True
    End Function
End Class
